#[doc = "Register `SILICON_ID` reader"]
pub struct R(crate::R<SILICON_ID_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<SILICON_ID_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<SILICON_ID_SPEC>> for R {
    fn from(reader: crate::R<SILICON_ID_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `SILICON_ID` writer"]
pub struct W(crate::W<SILICON_ID_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<SILICON_ID_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<SILICON_ID_SPEC>> for W {
    fn from(writer: crate::W<SILICON_ID_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `ID` reader - Silicon ID"]
pub struct ID_R(crate::FieldReader<u16, u16>);
impl ID_R {
    pub(crate) fn new(bits: u16) -> Self {
        ID_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for ID_R {
    type Target = crate::FieldReader<u16, u16>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `ID` writer - Silicon ID"]
pub struct ID_W<'a> {
    w: &'a mut W,
}
impl<'a> ID_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xffff) | (value as u32 & 0xffff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:15 - Silicon ID"]
    #[inline(always)]
    pub fn id(&self) -> ID_R {
        ID_R::new((self.bits & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Bits 0:15 - Silicon ID"]
    #[inline(always)]
    pub fn id(&mut self) -> ID_W {
        ID_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Silicon ID\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [silicon_id](index.html) module"]
pub struct SILICON_ID_SPEC;
impl crate::RegisterSpec for SILICON_ID_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [silicon_id::R](R) reader structure"]
impl crate::Readable for SILICON_ID_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [silicon_id::W](W) writer structure"]
impl crate::Writable for SILICON_ID_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets SILICON_ID to value 0"]
impl crate::Resettable for SILICON_ID_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
